unit ASN1DemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls,
  Asn1;

type
  TfrmASN1DemoMain = class(TForm)
    PageControl1: TPageControl;
    tabIntro: TTabSheet;
    memIntroduction: TMemo;
    tabBasicSyntax: TTabSheet;
    memBasicSyntaxModule: TMemo;
    Label1: TLabel;
    memBasicSyntaxDescr: TMemo;
    btnBasicSyntaxLoad: TButton;
    lblBasicSyntaxField1: TLabel;
    edtBasicSyntaxField1: TEdit;
    lblBasicSyntaxField2: TLabel;
    edtBasicSyntaxField2: TEdit;
    btnBasicSyntaxUpdateByIndex: TButton;
    Label2: TLabel;
    Label3: TLabel;
    btnBasicSyntaxUpdateByName: TButton;
    memBasicSyntaxDisplay: TMemo;
    tabBackward: TTabSheet;
    Label4: TLabel;
    memBackwardModuleOld: TMemo;
    btnBackwardLoadOld: TButton;
    lblBackwardField1Old: TLabel;
    edtBackwardField1Old: TEdit;
    lblBackwardField2Old: TLabel;
    edtBackwardField2Old: TEdit;
    Label7: TLabel;
    btnBackwardUpdateOldByIndex: TButton;
    btnBackwardUpdateOldByName: TButton;
    Label8: TLabel;
    memBackwardDisplayOld: TMemo;
    Label9: TLabel;
    memBackwardModuleNew: TMemo;
    btnBackWardLoadNew: TButton;
    lblBackwardField1New: TLabel;
    edtBackwardField1New: TEdit;
    lblBackwardField2New: TLabel;
    edtBackwardField2New: TEdit;
    Label12: TLabel;
    btnBackwardUpdateNewByIndex: TButton;
    btnBackwardUpdateNewByName: TButton;
    Label13: TLabel;
    memBackwardDisplayNew: TMemo;
    lblBackwardField3New: TLabel;
    edtBackwardField3New: TEdit;
    memBackwardDescr: TMemo;
    tabTagged: TTabSheet;
    Label5: TLabel;
    memTaggedModule: TMemo;
    btnTaggedLoad: TButton;
    lblTaggedField1: TLabel;
    edtTaggedField1: TEdit;
    lblTaggedField2: TLabel;
    edtTaggedField2: TEdit;
    Label11: TLabel;
    btnTaggedUpdateByIndex: TButton;
    Label14: TLabel;
    btnTaggedUpdateByName: TButton;
    memTaggedDisplay: TMemo;
    lblTaggedField3: TLabel;
    edtTaggedField3: TEdit;
    lblTaggedField4: TLabel;
    edtTaggedField4: TEdit;
    lblTaggedField5: TLabel;
    edtTaggedField5: TEdit;
    memNestedDescr: TMemo;
    tabNested: TTabSheet;
    Label6: TLabel;
    memNestedModule: TMemo;
    btnNestedLoad: TButton;
    btnNestedAdd: TButton;
    memNestedDisplay: TMemo;
    procedure FormDestroy(Sender: TObject);
    procedure btnBasicSyntaxUpdateByIndexClick(Sender: TObject);
    procedure btnBasicSyntaxLoadClick(Sender: TObject);
    procedure btnBasicSyntaxUpdateByNameClick(Sender: TObject);
    procedure memBasicSyntaxModuleChange(Sender: TObject);
    procedure memBackwardModuleChange(Sender: TObject);
    procedure btnBackwardLoadOldClick(Sender: TObject);
    procedure btnBackWardLoadNewClick(Sender: TObject);
    procedure btnBackwardUpdateOldByIndexClick(Sender: TObject);
    procedure btnBackwardUpdateNewByIndexClick(Sender: TObject);
    procedure btnBackwardUpdateOldByNameClick(Sender: TObject);
    procedure btnBackwardUpdateNewByNameClick(Sender: TObject);
    procedure memTaggedModuleChange(Sender: TObject);
    procedure btnTaggedLoadClick(Sender: TObject);
    procedure btnTaggedUpdateByIndexClick(Sender: TObject);
    procedure btnTaggedUpdateByNameClick(Sender: TObject);
    procedure btnNestedLoadClick(Sender: TObject);
    procedure btnNestedAddClick(Sender: TObject);
  private
    FBasicSyntax: TASN1Struct;
    FBackward: TASN1Struct;
    FBackwardData: TMemoryStream;
    FNested: TASN1Struct;
    procedure EnableBasicSyntaxFields;
    procedure DisableBasicSyntaxFields;
    procedure LoadBasicSyntaxModule;
    procedure EnableBackwardOldFields;
    procedure DisableBackwardOldFields;
    procedure LoadBackwardOldModule;
    procedure EnableBackwardNewFields;
    procedure DisableBackwardNewFields;
    procedure LoadBackwardNewModule;
    procedure EnableTaggedFields;
    procedure DisableTaggedFields;
    procedure LoadTaggedModule;
  public
    { Public declarations }
  end;

var
  frmASN1DemoMain: TfrmASN1DemoMain;

implementation

{$R *.dfm}

procedure TfrmASN1DemoMain.DisableBasicSyntaxFields;
begin
  lblBasicSyntaxField1.Visible := False;
  lblBasicSyntaxField2.Visible := False;
  edtBasicSyntaxField1.Enabled := False;
  edtBasicSyntaxField2.Enabled := False;
  btnBasicSyntaxUpdateByIndex.Enabled := False;
  btnBasicSyntaxUpdateByName.Enabled := False;
end;

procedure TfrmASN1DemoMain.EnableBasicSyntaxFields;
begin
  lblBasicSyntaxField1.Visible := True;
  lblBasicSyntaxField2.Visible := True;
  edtBasicSyntaxField1.Text := '';
  edtBasicSyntaxField2.Text := '';
  edtBasicSyntaxField1.Enabled := True;
  edtBasicSyntaxField2.Enabled := True;       
  btnBasicSyntaxUpdateByIndex.Enabled := True;
  btnBasicSyntaxUpdateByName.Enabled := True;
end;

procedure TfrmASN1DemoMain.FormDestroy(Sender: TObject);
begin
  FBasicSyntax.Free;
  FBackward.Free;
  FBackwardData.Free;
  FNested.Free;
end;

procedure TfrmASN1DemoMain.LoadBasicSyntaxModule;
var
  SS: TStringStream;
begin
  FBasicSyntax.Free;
  FBasicSyntax := TASN1Struct.Create;
  SS := TStringStream.Create(memBasicSyntaxModule.Text);
  try
    FBasicSyntax.LoadFromStream(SS,fmtASN1);
    if FBasicSyntax.Constructed and (FBasicSyntax.ItemCount >= 2) then begin
      lblBasicSyntaxField1.Caption := FBasicSyntax.Items[0].VarName;
      lblBasicSyntaxField2.Caption := FBasicSyntax.Items[1].VarName;
      EnableBasicSyntaxFields;
    end else
      raise Exception.Create('Illegal type for this example');
  finally
    SS.Free;
  end;
end;

procedure TfrmASN1DemoMain.btnBasicSyntaxLoadClick(Sender: TObject);
begin
  LoadBasicSyntaxModule;
end;

procedure TfrmASN1DemoMain.btnBasicSyntaxUpdateByIndexClick(Sender: TObject);
begin
  FBasicSyntax.Items[0].EditContent(edtBasicSyntaxField1.Text);
  FBasicSyntax.Items[1].EditContent(edtBasicSyntaxField2.Text);
  memBasicSyntaxDisplay.Clear;
  RenderAsText(FBasicSyntax,memBasicSyntaxDisplay.Lines,True,True,True,0,256);
end;

procedure TfrmASN1DemoMain.btnBasicSyntaxUpdateByNameClick(Sender: TObject);
var
  P: PASN1Struct;
begin
  P := FBasicSyntax.FindField(lblBasicSyntaxField1.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBasicSyntaxField1.Text);
  P := FBasicSyntax.FindField(lblBasicSyntaxField2.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBasicSyntaxField2.Text);
  memBasicSyntaxDisplay.Clear;
  RenderAsText(FBasicSyntax,memBasicSyntaxDisplay.Lines,True,True,True,0,256);
end;

procedure TfrmASN1DemoMain.memBasicSyntaxModuleChange(Sender: TObject);
begin
  DisableBasicSyntaxFields;
end;

procedure TfrmASN1DemoMain.DisableBackwardNewFields;
begin
  lblBackwardField1New.Visible := False;
  lblBackwardField2New.Visible := False;
  lblBackwardField3New.Visible := False;
  edtBackwardField1New.Enabled := False;
  edtBackwardField2New.Enabled := False;
  edtBackwardField3New.Enabled := False;
  btnBackwardUpdateNewByIndex.Enabled := False;
  btnBackwardUpdateNewByName.Enabled := False;
end;

procedure TfrmASN1DemoMain.DisableBackwardOldFields;
begin
  lblBackwardField1Old.Visible := False;
  lblBackwardField2Old.Visible := False;
  edtBackwardField1Old.Enabled := False;
  edtBackwardField2Old.Enabled := False;
  btnBackwardUpdateOldByIndex.Enabled := False;
  btnBackwardUpdateOldByName.Enabled := False;
end;

procedure TfrmASN1DemoMain.EnableBackwardNewFields;
begin
  lblBackwardField1New.Visible := True;
  lblBackwardField2New.Visible := True;
  lblBackwardField3New.Visible := True; 
  edtBackwardField1New.Text := '';
  edtBackwardField2New.Text := '';
  edtBackwardField3New.Text := '';
  edtBackwardField1New.Enabled := True;
  edtBackwardField2New.Enabled := True;
  edtBackwardField3New.Enabled := True;
  btnBackwardUpdateNewByIndex.Enabled := True;
  btnBackwardUpdateNewByName.Enabled := True;
end;

procedure TfrmASN1DemoMain.EnableBackwardOldFields;
begin
  lblBackwardField1Old.Visible := True;
  lblBackwardField2Old.Visible := True;
  edtBackwardField1Old.Text := '';
  edtBackwardField2Old.Text := '';
  edtBackwardField1Old.Enabled := True;
  edtBackwardField2Old.Enabled := True;
  btnBackwardUpdateOldByIndex.Enabled := True;
  btnBackwardUpdateOldByName.Enabled := True;
end;

procedure TfrmASN1DemoMain.LoadBackwardNewModule;
var
  SS: TStringStream;
begin
  FBackward.Free;
  FBackward := TASN1Struct.Create;
  SS := TStringStream.Create(memBackwardModuleNew.Text);
  try
    FBackward.LoadFromStream(SS,fmtASN1);
    if FBackward.Constructed and (FBackward.ItemCount >= 3) then begin
      if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
        if FBackward.Items[0].Length > 0 then
          if FBackward.Items[0].ContentAsInteger > 1 then
            raise Exception.Create('Version not supported');
        lblBackwardField1New.Caption := FBackward.Items[1].VarName;
        lblBackwardField2New.Caption := FBackward.Items[2].VarName;
        lblBackwardField3New.Caption := FBackward.Items[3].VarName;
      end else begin
        lblBackwardField1New.Caption := FBackward.Items[0].VarName;
        lblBackwardField2New.Caption := FBackward.Items[1].VarName;
        lblBackwardField3New.Caption := FBackward.Items[2].VarName;
      end;
      EnableBackwardNewFields;
      if Assigned(FBackwardData) then begin
        FBackwardData.Position := 0;
        FBackward.LoadFromStream(FBackwardData,fmtDER);
        if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
          edtBackwardField1New.Text := FBackward.Items[1].DisplayContent;
          edtBackwardField2New.Text := FBackward.Items[2].DisplayContent;
          edtBackwardField3New.Text := FBackward.Items[3].DisplayContent;
        end else begin
          edtBackwardField1New.Text := FBackward.Items[0].DisplayContent;
          edtBackwardField2New.Text := FBackward.Items[1].DisplayContent;
          edtBackwardField3New.Text := FBackward.Items[2].DisplayContent;
        end;
      end;
    end else
      raise Exception.Create('Illegal type for this example');
  finally
    SS.Free;
  end;
end;

procedure TfrmASN1DemoMain.LoadBackwardOldModule;
var
  SS: TStringStream;
begin
  FBackward.Free;
  FBackward := TASN1Struct.Create;
  SS := TStringStream.Create(memBackwardModuleOld.Text);
  try
    FBackward.LoadFromStream(SS,fmtASN1);
    if FBackward.Constructed and (FBackward.ItemCount >= 2) then begin
      lblBackwardField1Old.Caption := FBackward.Items[0].VarName;
      lblBackwardField2Old.Caption := FBackward.Items[1].VarName;
      EnableBackwardOldFields;
      if Assigned(FBackwardData) then begin
        FBackwardData.Position := 0;
        FBackward.LoadFromStream(FBackwardData,fmtDER);
        edtBackwardField1Old.Text := FBackward.Items[0].DisplayContent;
        edtBackwardField2Old.Text := FBackward.Items[1].DisplayContent;
      end;
    end else
      raise Exception.Create('Illegal type for this example');
  finally
    SS.Free;
  end;
end;

procedure TfrmASN1DemoMain.memBackwardModuleChange(Sender: TObject);
begin
  DisableBackwardOldFields;
  DisableBackwardNewFields;
end;

procedure TfrmASN1DemoMain.btnBackwardLoadOldClick(Sender: TObject);
begin
  LoadBackwardOldModule;
end;

procedure TfrmASN1DemoMain.btnBackWardLoadNewClick(Sender: TObject);
begin
  LoadBackwardNewModule;
end;

procedure TfrmASN1DemoMain.btnBackwardUpdateOldByIndexClick(Sender: TObject);
begin
  FBackward.Items[0].EditContent(edtBackwardField1Old.Text);
  FBackward.Items[1].EditContent(edtBackwardField2Old.Text);
  memBackwardDisplayOld.Clear;
  RenderAsText(FBackward,memBackwardDisplayOld.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.btnBackwardUpdateNewByIndexClick(Sender: TObject);
begin
  if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
    FBackward.Items[0].EditContent(1,False);
    FBackward.Items[1].EditContent(edtBackwardField1New.Text);
    FBackward.Items[2].EditContent(edtBackwardField2New.Text);
    FBackward.Items[3].EditContent(edtBackwardField3New.Text);
  end else begin
    FBackward.Items[0].EditContent(edtBackwardField1New.Text);
    FBackward.Items[1].EditContent(edtBackwardField2New.Text);
    FBackward.Items[2].EditContent(edtBackwardField3New.Text);
  end;
  memBackwardDisplayNew.Clear;
  RenderAsText(FBackward,memBackwardDisplayNew.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.btnBackwardUpdateOldByNameClick(Sender: TObject);
var
  P: PASN1Struct;
begin
  P := FBackward.FindField(lblBackwardField1Old.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBackwardField1Old.Text);
  P := FBackward.FindField(lblBackwardField2Old.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBackwardField2Old.Text);
  memBackwardDisplayOld.Clear;
  RenderAsText(FBackward,memBackwardDisplayOld.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.btnBackwardUpdateNewByNameClick(Sender: TObject);
var
  P: PASN1Struct;
begin
  P := FBackward.FindField('version');
  if Assigned(P) then
    P.EditContent(1,False);
  P := FBackward.FindField(lblBackwardField1New.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBackwardField1New.Text);
  P := FBackward.FindField(lblBackwardField2New.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBackwardField2New.Text);
  P := FBackward.FindField(lblBackwardField3New.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtBackwardField3New.Text);
  memBackwardDisplayNew.Clear;
  RenderAsText(FBackward,memBackwardDisplayNew.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.DisableTaggedFields;
begin
  lblTaggedField1.Visible := False;
  lblTaggedField2.Visible := False;
  lblTaggedField3.Visible := False;
  lblTaggedField4.Visible := False;
  lblTaggedField5.Visible := False;
  edtTaggedField1.Enabled := False;
  edtTaggedField2.Enabled := False;
  edtTaggedField3.Enabled := False;
  edtTaggedField4.Enabled := False;
  edtTaggedField5.Enabled := False;
  btnTaggedUpdateByIndex.Enabled := False;
  btnTaggedUpdateByName.Enabled := False;
end;

procedure TfrmASN1DemoMain.EnableTaggedFields;
begin
  lblTaggedField1.Visible := True;
  lblTaggedField2.Visible := True;
  lblTaggedField3.Visible := True;
  lblTaggedField4.Visible := True;
  lblTaggedField5.Visible := True;
  edtTaggedField1.Text := '';
  edtTaggedField2.Text := '';
  edtTaggedField3.Text := '';
  edtTaggedField4.Text := '';
  edtTaggedField5.Text := '';
  edtTaggedField1.Enabled := True;
  edtTaggedField2.Enabled := True;
  edtTaggedField3.Enabled := True;
  edtTaggedField4.Enabled := True;
  edtTaggedField5.Enabled := True;
  btnTaggedUpdateByIndex.Enabled := True;
  btnTaggedUpdateByName.Enabled := True;
end;

procedure TfrmASN1DemoMain.LoadTaggedModule;
var
  SS: TStringStream;
begin
  FBackward.Free;
  FBackward := TASN1Struct.Create;
  SS := TStringStream.Create(memTaggedModule.Text);
  try
    FBackward.LoadFromStream(SS,fmtASN1);
    if FBackward.Constructed and (FBackward.ItemCount >= 3) then begin
      if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
        if FBackward.Items[0].Length > 0 then
          if FBackward.Items[0].ContentAsInteger > 2 then
            raise Exception.Create('Version not supported');
        lblTaggedField1.Caption := FBackward.Items[1].VarName;
        lblTaggedField2.Caption := FBackward.Items[2].VarName;
        lblTaggedField3.Caption := FBackward.Items[3].VarName;
        lblTaggedField4.Caption := FBackward.Items[4].VarName;
        lblTaggedField5.Caption := FBackward.Items[5].VarName;
      end else begin
        lblTaggedField1.Caption := FBackward.Items[0].VarName;
        lblTaggedField2.Caption := FBackward.Items[1].VarName;
        lblTaggedField3.Caption := FBackward.Items[2].VarName;
        lblTaggedField4.Caption := FBackward.Items[3].VarName;
        lblTaggedField5.Caption := FBackward.Items[4].VarName;
      end;
      EnableTaggedFields;
      if Assigned(FBackwardData) then begin
        FBackwardData.Position := 0;
        FBackward.LoadFromStream(FBackwardData,fmtDER);
        if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
          edtTaggedField1.Text := FBackward.Items[1].DisplayContent;
          edtTaggedField2.Text := FBackward.Items[2].DisplayContent;
          edtTaggedField3.Text := FBackward.Items[3].DisplayContent;
          edtTaggedField4.Text := FBackward.Items[4].DisplayContent;
          edtTaggedField5.Text := FBackward.Items[5].DisplayContent;
        end else begin
          edtTaggedField1.Text := FBackward.Items[0].DisplayContent;
          edtTaggedField2.Text := FBackward.Items[1].DisplayContent;
          edtTaggedField3.Text := FBackward.Items[2].DisplayContent;
          edtTaggedField4.Text := FBackward.Items[3].DisplayContent;
          edtTaggedField5.Text := FBackward.Items[4].DisplayContent;
        end;
      end;
    end else
      raise Exception.Create('Illegal type for this example');
  finally
    SS.Free;
  end;
end;

procedure TfrmASN1DemoMain.memTaggedModuleChange(Sender: TObject);
begin
  DisableTaggedFields;
end;

procedure TfrmASN1DemoMain.btnTaggedLoadClick(Sender: TObject);
begin
  LoadTaggedModule;
end;

procedure TfrmASN1DemoMain.btnTaggedUpdateByIndexClick(Sender: TObject);
begin
  if FBackward.Items[0].ActualTag = V_ASN1_INTEGER then begin
    FBackward.Items[0].EditContent(2,False);
    FBackward.Items[1].EditContent(edtTaggedField1.Text);
    FBackward.Items[2].EditContent(edtTaggedField2.Text);
    FBackward.Items[3].EditContent(edtTaggedField3.Text);
    FBackward.Items[4].EditContent(edtTaggedField4.Text);
    FBackward.Items[5].EditContent(edtTaggedField5.Text);
  end else begin
    FBackward.Items[0].EditContent(edtTaggedField1.Text);
    FBackward.Items[1].EditContent(edtTaggedField2.Text);
    FBackward.Items[2].EditContent(edtTaggedField3.Text);
    FBackward.Items[3].EditContent(edtTaggedField4.Text);
    FBackward.Items[4].EditContent(edtTaggedField5.Text);
  end;
  memTaggedDisplay.Clear;
  RenderAsText(FBackward,memTaggedDisplay.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.btnTaggedUpdateByNameClick(Sender: TObject);
var
  P: PASN1Struct;
begin
  P := FBackward.FindField('version');
  if Assigned(P) then
    P.EditContent(2,False);
  P := FBackward.FindField(lblTaggedField1.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtTaggedField1.Text);
  P := FBackward.FindField(lblTaggedField2.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtTaggedField2.Text);
  P := FBackward.FindField(lblTaggedField3.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtTaggedField3.Text);
  P := FBackward.FindField(lblTaggedField4.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtTaggedField4.Text);
  P := FBackward.FindField(lblTaggedField5.Caption);
  Assert(Assigned(P)); // It is good practice to add this test
  P.EditContent(edtTaggedField5.Text);
  memTaggedDisplay.Clear;
  RenderAsText(FBackward,memTaggedDisplay.Lines,True,True,True,0,256);
  FBackwardData.Free;
  FBackwardData := TMemoryStream.Create;
  FBackward.SaveToStream(FBackwardData,fmtDER);
end;

procedure TfrmASN1DemoMain.btnNestedLoadClick(Sender: TObject);
var
  SS: TStringStream;
begin
  LoadTaggedModule;
  FNested.Free;
  FNested := TASN1Struct.Create;
  SS := TStringStream.Create(memNestedModule.Text);
  try
    FNested.LoadFromStream(SS,fmtASN1);
  finally
    SS.Free;
  end;
//  btnNested.Enabled := Assigned(FBackwardData);
end;

procedure TfrmASN1DemoMain.btnNestedAddClick(Sender: TObject);
begin
  if Assigned(FNested) and Assigned(FBackwardData) then begin
    FBackwardData.Position := 0;
    with FNested.AddField^ do begin
      Items[0].EditContent(FNested.ItemCount);
      Items[1].LoadFromStream(FBackwardData,fmtDER);
    end;
    memNestedDisplay.Clear;
    RenderAsText(FNested,memNestedDisplay.Lines,True,True,True,0,256);
  end;
end;

end.
