unit CertModule;

interface

uses
  Forms, SysUtils, Classes, MpX509, TlsInternalServer, SecComp, StreamSecII,
  SecUtils, Asn1;

type
  TdmCerts = class(TDataModule)
    KeysAndCerts: TSimpleTLSInternalServer;
    PrivateKeyRing: TSsPrivateKeyRingComponent;
    procedure PrivateKeyRingPassword(Sender: TObject;
      Password: ISecretKey);
    procedure PrivateKeyRingAdminPassword(Sender: TObject;
      Password: ISecretKey);
    procedure KeysAndCertsCertNotTrusted(Sender: TObject;
      Cert: TASN1Struct; var ExplicitTrust: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dmCerts: TdmCerts;

implementation

{$R *.dfm}

procedure TdmCerts.PrivateKeyRingPassword(Sender: TObject;
  Password: ISecretKey);
begin
  // Just to prevent the dialogs from popping up
  Password.SetKeyStr('abc');
end;

procedure TdmCerts.PrivateKeyRingAdminPassword(Sender: TObject;
  Password: ISecretKey);
begin                                           
  // Just to prevent the dialogs from popping up
  Password.SetKeyStr('abc');
end;

procedure TdmCerts.KeysAndCertsCertNotTrusted(Sender: TObject;
  Cert: TASN1Struct; var ExplicitTrust: Boolean);
begin
  ExplicitTrust := False;
  // Note: Since the component does not know of any CA certificates at start up
  // setting ExplicitTrust to False (the default) means that KeysAndCerts will
  // ONLY accept the personal certificate that has a matching private key.
  // For the purposes of this demo this is exactly what we want.
end;

end.
