unit SignedDataMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfrmSignedDataMain = class(TForm)
    btnVerify: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    chbAllowExpired: TCheckBox;
    Label1: TLabel;
    memResults: TMemo;
    procedure btnVerifyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSignedDataMain: TfrmSignedDataMain;

implementation

uses
  SignedDataDM;

{$R *.dfm}

procedure TfrmSignedDataMain.btnVerifyClick(Sender: TObject);
var
  DstFileName: string;
begin
  if OpenDialog1.Execute then begin
    DstFileName := OpenDialog1.FileName;
    UniqueString(DstFileName);
    while (DstFileName <> '') and (DstFileName[Length(DstFileName)] <> '.') do
      Delete(DstFileName,Length(DstFileName),1);
    if DstFileName <> '' then
      Delete(DstFileName,Length(DstFileName),1);
    SaveDialog1.FileName := DstFileName;
    if SaveDialog1.Execute then begin
      dmSignedData.MPSignedData1.AllowExpiredCertificates := chbAllowExpired.Checked;
      memResults.Clear;
      memResults.Lines.Add(Format('Checking file %s for CMS signatures.',
                                  [OpenDialog1.FileName]));
      memResults.Lines.Add(Format('Content output to file %s.',
                                  [SaveDialog1.FileName]));
      memResults.Lines.Add('*****');
      if dmSignedData.Verify(OpenDialog1.FileName,SaveDialog1.FileName) then
        memResults.Lines.Add('Verification successful')
      else
        memResults.Lines.Add('Verification failed');       
      memResults.Lines.Add('*****');
      if dmSignedData.MPSignedData1.SigningDescription <> '' then
        memResults.Lines.Add('Signing Description: ' +
                             dmSignedData.MPSignedData1.SigningDescription);
      if dmSignedData.MPSignedData1.CertificateNotFound then
        memResults.Lines.Add('At least one certificates was not found.');
      memResults.Lines.Add(Format('Bad certificates: %d',
                                  [dmSignedData.BadCertificates]));
      memResults.Lines.Add(Format('Bad signatures: %d',
                                  [dmSignedData.BadSignatures]));
      memResults.Lines.Add(Format('Good signatures: %d',
                                  [dmSignedData.GoodSignatures]));
    end;
  end;
end;

end.
