unit CertMgrCliYarrow;

interface

procedure Accumulate(AHandle: LongInt; Seed: Pointer; SeedLen: LongInt); stdcall;
procedure GetSeed(AHandle: LongInt; Seed: Pointer; SeedLen: LongInt); stdcall;

implementation

uses
  uROTypes,
  CertMgrSrv_Intf,
  CertMgrCliModule;


procedure Accumulate(AHandle: LongInt; Seed: Pointer; SeedLen: LongInt); stdcall;
var
  DM: TClientModule;
  Intf: IYarrow;
  Sd: Binary;
begin
  DM := TClientModule(AHandle);
  Intf := DM.RORemoteService as IYarrow;
  Sd := Binary.Create;
  try
    Sd.Write(Seed^,SeedLen);
    Sd.Position := 0;
    Intf.Accumulate(Sd);
  finally
    Sd.Free;
  end;
end;

procedure GetSeed(AHandle: LongInt; Seed: Pointer; SeedLen: LongInt); stdcall;
var
  DM: TClientModule;
  Intf: IYarrow;
  Sd: Binary;
begin
  DM := TClientModule(AHandle);
  Intf := DM.RORemoteService as IYarrow;
  Intf.GetSeed(Sd);
  try                       
    Sd.Position := 0;
    Sd.Read(Seed^,SeedLen);
  finally
    Sd.Free;
  end;
end;

end.
