unit CertMgrSrv_Intf;

{----------------------------------------------------------------------------}
{ This unit was automatically generated by the RemObjects SDK after reading  }
{ the RODL file associated with this project .                               }
{                                                                            }
{ Do not modify this unit manually, or your changes will be lost when this   }
{ unit is regenerated the next time you compile the project.                 }
{----------------------------------------------------------------------------}

interface

uses
  {vcl:} Classes, TypInfo,
  {RemObjects:} uROClasses, uROClient, uROTypes, uROClientIntf;

const
  { Library ID }
  LibraryUID = '{5A3AD8DF-4EC3-4A1E-8B47-3053C993C514}';

  { Service Interface ID's }
  IYarrow_IID : TGUID = '{248C70A3-CE28-4D23-9953-16AD64EBC766}';
  ICertMgrSrvc_IID : TGUID = '{63B7BC0A-462A-45B5-8E18-83D21A5027E5}';

  { Event ID's }

type
  { Forward declarations }
  IYarrow = interface;
  ICertMgrSrvc = interface;

  TStringArray = class;

  EStoreNotFound = class;
  EAlreadyLoggedIn = class;


  { TStringArray }
  TStringArray = class(TROArray)
  private
    fCount: Integer;
    fItems : array of Widestring;
  protected
    procedure Grow; virtual;
    function GetItems(Index: integer): Widestring;
    procedure SetItems(Index: integer; const Value: Widestring);
    function GetCount: integer; override;
  public
    class function GetItemType: PTypeInfo; override;
    class function GetItemSize: integer; override;
    function GetItemRef(Index: integer): pointer; override;
    procedure Clear; override;
    procedure Delete(Index: integer); override;
    procedure Resize(ElementCount: integer); override;

    procedure Assign(iSource:TPersistent); override;
    function Add(const Value:Widestring): integer;

    property Count : integer read GetCount;
    property Items[Index: integer]:Widestring read GetItems write SetItems; default;
  end;

  { Exceptions }
  EStoreNotFound = class(EROException)
  private
  public
  published
  end;

  EAlreadyLoggedIn = class(EROException)
  private
  public
  published
  end;


  { IYarrow }

  { Description:
      Service Yarrow. }
  IYarrow = interface
    ['{248C70A3-CE28-4D23-9953-16AD64EBC766}']
    procedure Accumulate(const Seed: Binary);
    procedure GetSeed(out Seed: Binary);
  end;

  { CoYarrow }
  CoYarrow = class
    class function Create(const aMessage: IROMessage; aTransportChannel: IROTransportChannel): IYarrow;
  end;

  { TYarrow_Proxy }
  TYarrow_Proxy = class(TROProxy, IYarrow)
  protected
    function __GetInterfaceName:string; override;

    procedure Accumulate(const Seed: Binary);
    procedure GetSeed(out Seed: Binary);
  end;

  { ICertMgrSrvc }

  { Description:
      StreamSec Certificate Manager Service }
  ICertMgrSrvc = interface
    ['{63B7BC0A-462A-45B5-8E18-83D21A5027E5}']
    function SetStore(const StoreName: Widestring; const StorePath: Widestring): Integer;
    procedure AddCert(const Handle: Integer; const Cert: Binary);
    procedure RemoveCert(const Handle: Integer; const Cert: Binary);
    function FindCert(const Cert: Binary): Boolean;
    function ActivateQuery(const Handle: Integer): Integer;
    function ListCACerts: Binary;
    function SignCertReq(const CACertStoreName: Widestring; const CertReq: Binary): Binary;
    function CheckSignCertReq(const Handle: Integer; out CertReq: Binary): Boolean;
    procedure SignedCertReq(const Handle: Integer; const Cert: Binary);
    procedure CloseStore(const Handle: Integer);
  end;

  { CoCertMgrSrvc }
  CoCertMgrSrvc = class
    class function Create(const aMessage: IROMessage; aTransportChannel: IROTransportChannel): ICertMgrSrvc;
  end;

  { TCertMgrSrvc_Proxy }
  TCertMgrSrvc_Proxy = class(TROProxy, ICertMgrSrvc)
  protected
    function __GetInterfaceName:string; override;

    function SetStore(const StoreName: Widestring; const StorePath: Widestring): Integer;
    procedure AddCert(const Handle: Integer; const Cert: Binary);
    procedure RemoveCert(const Handle: Integer; const Cert: Binary);
    function FindCert(const Cert: Binary): Boolean;
    function ActivateQuery(const Handle: Integer): Integer;
    function ListCACerts: Binary;
    function SignCertReq(const CACertStoreName: Widestring; const CertReq: Binary): Binary;
    function CheckSignCertReq(const Handle: Integer; out CertReq: Binary): Boolean;
    procedure SignedCertReq(const Handle: Integer; const Cert: Binary);
    procedure CloseStore(const Handle: Integer);
  end;

implementation

uses
  {vcl:} SysUtils,
  {RemObjects:} uROEventRepository, uRORes;

{ TStringArray }

procedure TStringArray.Assign(iSource: TPersistent);
var lSource:TStringArray;
    i:integer;
begin
  if (iSource is TStringArray) then begin
    lSource := TStringArray(iSource);
    Clear();
    Resize(lSource.Count);
    for i := 0 to Count-1 do begin
      Items[i] := lSource.Items[i];
    end;
  end
  else begin
    inherited Assign(iSource);
  end;
end;

class function TStringArray.GetItemType: PTypeInfo;
begin
  result := TypeInfo(Widestring);
end;

class function TStringArray.GetItemSize: integer;
begin
  result := SizeOf(Widestring);
end;

function TStringArray.GetItems(Index: integer): Widestring;
begin
  if (Index < 0) or (Index >= Count) then RaiseError(err_ArrayIndexOutOfBounds,[Index]);
  result := fItems[Index];
end;

function TStringArray.GetItemRef(Index: integer): pointer;
begin
  if (Index < 0) or (Index >= Count) then RaiseError(err_ArrayIndexOutOfBounds,[Index]);
  result := @fItems[Index];
end;

procedure TStringArray.Clear;
begin
  SetLength(fItems, 0);
  FCount := 0;
end;

procedure TStringArray.Delete(Index: integer);
var i: integer;
begin
  if (Index>=Count) then RaiseError(err_InvalidIndex, [Index]);

  if (Index<Count-1) then
    for i := Index to Count-2 do fItems[i] := fItems[i+1];

  SetLength(fItems, Count-1);
  Dec(FCount);
end;

procedure TStringArray.SetItems(Index: integer; const Value: Widestring);
begin
  if (Index < 0) or (Index >= Count) then RaiseError(err_ArrayIndexOutOfBounds,[Index]);
  fItems[Index] := Value;
end;

procedure TStringArray.Resize(ElementCount: integer);
begin
  SetLength(fItems, ElementCount);
  FCount := ElementCount;
end;

function TStringArray.GetCount: integer;
begin
  result := FCount;
end;

procedure TStringArray.Grow;
var
  Delta, Capacity: Integer;
begin
  Capacity := Length(fItems);
  if Capacity > 64 then
    Delta := Capacity div 4
  else
    if Capacity > 8 then
      Delta := 16
   else
      Delta := 4;
  SetLength(fItems, Capacity + Delta);
end;

function TStringArray.Add(const Value: Widestring): integer;
begin
  Result := Count;
  if Length(fItems) = Result then
    Grow;
  fItems[result] := Value;
  Inc(fCount);
end;

{ CoYarrow }

class function CoYarrow.Create(const aMessage: IROMessage; aTransportChannel: IROTransportChannel): IYarrow;
begin
  result := TYarrow_Proxy.Create(aMessage, aTransportChannel);
end;

{ TYarrow_Proxy }

function TYarrow_Proxy.__GetInterfaceName:string;
begin
  result := 'Yarrow';
end;

procedure TYarrow_Proxy.Accumulate(const Seed: Binary);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'Accumulate');
     __Message.Write('Seed', TypeInfo(Binary), Seed, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

  finally
    __request.Free;
    __response.Free;
  end
end;

procedure TYarrow_Proxy.GetSeed(out Seed: Binary);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'GetSeed');
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Seed', TypeInfo(Binary), Seed, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

{ CoCertMgrSrvc }

class function CoCertMgrSrvc.Create(const aMessage: IROMessage; aTransportChannel: IROTransportChannel): ICertMgrSrvc;
begin
  result := TCertMgrSrvc_Proxy.Create(aMessage, aTransportChannel);
end;

{ TCertMgrSrvc_Proxy }

function TCertMgrSrvc_Proxy.__GetInterfaceName:string;
begin
  result := 'CertMgrSrvc';
end;

function TCertMgrSrvc_Proxy.SetStore(const StoreName: Widestring; const StorePath: Widestring): Integer;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'SetStore');
     __Message.Write('StoreName', TypeInfo(Widestring), StoreName, []);
     __Message.Write('StorePath', TypeInfo(Widestring), StorePath, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Integer), result, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

procedure TCertMgrSrvc_Proxy.AddCert(const Handle: Integer; const Cert: Binary);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'AddCert');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Write('Cert', TypeInfo(Binary), Cert, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

  finally
    __request.Free;
    __response.Free;
  end
end;

procedure TCertMgrSrvc_Proxy.RemoveCert(const Handle: Integer; const Cert: Binary);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'RemoveCert');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Write('Cert', TypeInfo(Binary), Cert, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

  finally
    __request.Free;
    __response.Free;
  end
end;

function TCertMgrSrvc_Proxy.FindCert(const Cert: Binary): Boolean;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'FindCert');
     __Message.Write('Cert', TypeInfo(Binary), Cert, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Boolean), result, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

function TCertMgrSrvc_Proxy.ActivateQuery(const Handle: Integer): Integer;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'ActivateQuery');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Integer), result, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

function TCertMgrSrvc_Proxy.ListCACerts: Binary;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'ListCACerts');
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Binary), result, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

function TCertMgrSrvc_Proxy.SignCertReq(const CACertStoreName: Widestring; const CertReq: Binary): Binary;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'SignCertReq');
     __Message.Write('CACertStoreName', TypeInfo(Widestring), CACertStoreName, []);
     __Message.Write('CertReq', TypeInfo(Binary), CertReq, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Binary), result, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

function TCertMgrSrvc_Proxy.CheckSignCertReq(const Handle: Integer; out CertReq: Binary): Boolean;
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'CheckSignCertReq');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

     __Message.Read('Result', TypeInfo(Boolean), result, []);
     __Message.Read('CertReq', TypeInfo(Binary), CertReq, []);
  finally
    __request.Free;
    __response.Free;
  end
end;

procedure TCertMgrSrvc_Proxy.SignedCertReq(const Handle: Integer; const Cert: Binary);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'SignedCertReq');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Write('Cert', TypeInfo(Binary), Cert, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

  finally
    __request.Free;
    __response.Free;
  end
end;

procedure TCertMgrSrvc_Proxy.CloseStore(const Handle: Integer);
var __request, __response : TMemoryStream;
begin
  __request := TMemoryStream.Create;
  __response := TMemoryStream.Create;

  try
     __Message.Initialize(__TransportChannel, 'CertMgrSrv', __InterfaceName, 'CloseStore');
     __Message.Write('Handle', TypeInfo(Integer), Handle, []);
     __Message.Finalize;

     __Message.WriteToStream(__request);
     __TransportChannel.Dispatch(__request, __response);
     __Message.ReadFromStream(__response);

  finally
    __request.Free;
    __response.Free;
  end
end;

initialization
  RegisterROClass(TStringArray);
  RegisterExceptionClass(EStoreNotFound);
  RegisterExceptionClass(EAlreadyLoggedIn);
  RegisterProxyClass(IYarrow_IID, TYarrow_Proxy);
  RegisterProxyClass(ICertMgrSrvc_IID, TCertMgrSrvc_Proxy);


finalization
  UnregisterROClass(TStringArray);
  UnregisterExceptionClass(EStoreNotFound);
  UnregisterExceptionClass(EAlreadyLoggedIn);
  UnregisterProxyClass(IYarrow_IID);
  UnregisterProxyClass(ICertMgrSrvc_IID);

end.
