unit CertMgrSrvc_Impl;

{----------------------------------------------------------------------------}
{ This unit was automatically generated by the RemObjects SDK after reading  }
{ the RODL file associated with this project .                               }
{                                                                            }
{ This is where you are supposed to code the implementation of your objects. }
{----------------------------------------------------------------------------}

interface

uses
  {vcl:} Classes, SysUtils,
  {RemObjects:} uROClientIntf, uROTypes, uROServer, uROServerIntf, uROSessions,
  {Generated:} CertMgrSrv_Intf;

type
  { TCertMgrSrvc }
  TCertMgrSrvc = class(TRORemotable, ICertMgrSrvc)
  private
  protected
    { ICertMgrSrvc methods }
    function SetStore(const StoreName: Widestring; const StorePath: Widestring): Integer;
    procedure AddCert(const Handle: Integer; const Cert: Binary);
    procedure RemoveCert(const Handle: Integer; const Cert: Binary);
    function FindCert(const Cert: Binary): Boolean;
    function ActivateQuery(const Handle: Integer): Integer;
    function ListCACerts: Binary;
    function SignCertReq(const CACertStoreName: WideString; const CertReq: Binary): Binary;
    function CheckSignCertReq(const Handle: Integer; out CertReq: Binary): Boolean; 
    procedure SignedCertReq(const Handle: Integer; const Cert: Binary);
    procedure CloseStore(const Handle: Integer);
  end;

implementation

uses
  {Generated:} CertMgrSrv_Invk,
  CertStoreModule;

procedure Create_CertMgrSrvc(out anInstance : IUnknown);
begin
  anInstance := TCertMgrSrvc.Create;
end;

{ CertMgrSrvc }
function TCertMgrSrvc.SetStore(const StoreName: Widestring; const StorePath: Widestring): Integer;
var
  DM: TStoreModule;
begin
  DM := FindModule(StoreName,StorePath);
  if Assigned(DM) then begin
    Result := DM.LogIn;
    if Result < 0 then
      raise EAlreadyLoggedIn.CreateFmt('Already logged in to %s',[StorePath]);
  end else
    raise EStoreNotFound.Create('Store not found');
end;

procedure TCertMgrSrvc.AddCert(const Handle: Integer; const Cert: Binary);
var
  DM: TStoreModule;
begin
  DM := FindModule(Handle);
  if Assigned(DM) then
    DM.AddCert(Cert)
  else
    raise EStoreNotFound.Create('Store not found');
end;

procedure TCertMgrSrvc.RemoveCert(const Handle: Integer; const Cert: Binary);
var
  DM: TStoreModule;
begin
  DM := FindModule(Handle);
  if Assigned(DM) then
    DM.RemoveCert(Cert)
  else
    raise EStoreNotFound.Create('Store not found');
end;

function TCertMgrSrvc.FindCert(const Cert: Binary): Boolean;
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindCert(Cert);
  if Assigned(DM) then begin
    DM.ActivateCert(Cert);
    Result := True;
  end else
    Result := False;
end;

function TCertMgrSrvc.ActivateQuery(const Handle: Integer): Integer;
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindModule(Handle);
  if Assigned(DM) then begin
    Result := DM.Selected;
    if Result >= 0 then
      DM.ActivateCert(nil);
  end else
    raise EStoreNotFound.Create('Store not found');
end;

function TCertMgrSrvc.ListCACerts: Binary;
begin
  Result := Binary.Create;
  CertStoreModule.ListCACerts(Result);
end;

procedure TCertMgrSrvc.CloseStore(const Handle: Integer);
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindModule(Handle);
  if Assigned(DM) then
    DM.Logout
  else
    raise EStoreNotFound.Create('Store not found');
end;

function TCertMgrSrvc.SignCertReq(const CACertStoreName: WideString; const CertReq: Binary): Binary;
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindModule(CACertStoreName,'');
  if Assigned(DM) then
    Result := DM.SignCertReq(CertReq)
  else
    raise EStoreNotFound.Create('Store not found');
end;

function TCertMgrSrvc.CheckSignCertReq(const Handle: Integer;
  out CertReq: Binary): Boolean;
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindModule(Handle);
  if Assigned(DM) then
    Result := DM.CheckSignCertReq(CertReq)
  else
    raise EStoreNotFound.Create('Store not found');
end;

procedure TCertMgrSrvc.SignedCertReq(const Handle: Integer;
  const Cert: Binary);
var
  DM: TStoreModule;
begin
  DM := CertStoreModule.FindModule(Handle);
  if Assigned(DM) then
    DM.SignedCertReq(Cert)
  else
    raise EStoreNotFound.Create('Store not found');
end;

initialization
  TROClassFactory.Create('CertMgrSrvc', Create_CertMgrSrvc, TCertMgrSrvc_Invoker);

finalization

end.
