unit fServerForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  uROClient, uROPoweredByRemObjectsButton, uROClientIntf, uROServer,
  uROBinMessage, uRONamedPipeServer, uROBaseConnection, JvComponent,
  JvTrayIcon, Menus;

type
  TServerForm = class(TForm)
    RoPoweredByRemObjectsButton1: TRoPoweredByRemObjectsButton;
    ROMessage: TROBinMessage;
    ROServer: TRONamedPipeServer;
    JvTrayIcon1: TJvTrayIcon;
    PopupMenu1: TPopupMenu;
    StreamSecCertMgr1: TMenuItem;
    Copyrightc200220041: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    procedure PopupClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  ServerForm: TServerForm;

implementation

uses
  SsCertMgrUtils,
  CertStoreModule;

{$R *.dfm}

procedure TServerForm.FormCreate(Sender: TObject);
var
  SL: TStringList;
  MI: TMenuItem;
begin
  SL := TStringList.Create;
  try
    TSsCertMgrPaths.GetNamesAndPaths(SL);
    while SL.Count > 0 do begin
      MI := TMenuItem.Create(PopupMenu1);
      MI.Caption := SL.Names[SL.Count - 1];
      MI.OnClick := PopupClick;
      PopupMenu1.Items.Insert(3,MI);
      SL.Delete(SL.Count - 1);
    end;
  finally
    SL.Free;
  end;
  ROServer.Active := True;
end;

procedure TServerForm.FormDestroy(Sender: TObject);
begin
  ROServer.Active := False;
end;

procedure TServerForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TServerForm.PopupClick(Sender: TObject);
begin
  CertStoreModule.FindModule(TMenuItem(Sender).Caption,'').ActivateAny;
end;

procedure TServerForm.PopupMenu1Popup(Sender: TObject);
var
  SL: TStringList;
  I: Integer;
begin
  Exit1.Enabled := True;
  SL := TStringList.Create;
  try
    TSsCertMgrPaths.GetPaths(SL);
    for I := 0 to SL.Count - 1 do
      if TSsCertMgrPaths.PathIsLocked(SL[I]) then begin
        Exit1.Enabled := False;
        Break;
      end;
  finally
    SL.Free;
  end;
end;

end.
