unit Setup;

interface

uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   StdCtrls, Buttons, ComCtrls;

type
   TfmSetup = class(TForm)
      BitBtn1: TBitBtn;
    pcSetup: TPageControl;
    tsPop3: TTabSheet;
    tsSmtp: TTabSheet;
    Label1: TLabel;
    POPServer: TEdit;
    Label2: TLabel;
    POPPort: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    lblAuthenticationType: TLabel;
    cboAuthType: TComboBox;
    lbAccount: TLabel;
    edtAccount: TEdit;
    lbPassword: TLabel;
    edtPassword: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    SMTPServer: TEdit;
    SMTPPort: TEdit;
    Email: TEdit;
    Account: TEdit;
    Password: TEdit;
    tsSMIME: TTabSheet;
    Label3: TLabel;
    edtRootCerts: TEdit;
    Label4: TLabel;
    edtPrivateKeyRing: TEdit;
    Label5: TLabel;
    edtMyCerts: TEdit;
    Label6: TLabel;
    edtCollectedCerts: TEdit;
    btnEditRootCerts: TButton;
    btnEditMyCerts: TButton;
    btnEditCollectedCerts: TButton;
      procedure bbtnAuthenticationClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure FormHide(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnEditRootCertsClick(Sender: TObject);
    procedure btnEditMyCertsClick(Sender: TObject);
    procedure btnEditCollectedCertsClick(Sender: TObject);
   private
    { Private declarations }
   public
    { Public declarations }
      procedure UpdateServerLabel;
   end;

var
   fmSetup: TfmSetup;

implementation

uses
  CertEdit, MailClientMain, smtpauth, inifiles;

{$R *.DFM}

procedure TfmSetup.bbtnAuthenticationClick(Sender: TObject);
begin
   frmSMTPAuthentication.ShowModal;
end;

procedure TfmSetup.UpdateServerLabel;
begin
   frmMain.pnlServerName.caption := POPServer.Text;
end; (*  *)

procedure TfmSetup.FormCreate(Sender: TObject);
begin
  POPServer.Text := Pop3ServerName;
  POPPort.Text := IntToStr(Pop3ServerPort);
  Account.Text := Pop3ServerUser;
  Password.Text := Pop3ServerPassword;

  SMTPServer.Text := SmtpServerName;
  SMTPPort.Text := IntToStr(SmtpServerPort);
  edtAccount.Text := SmtpServerUser;
  edtPassword.Text := SmtpServerPassword;
  cboAuthType.ItemIndex := SmtpAuthType;

  Email.Text := UserEmail;

  edtRootCerts.Text := RootCertsFile;
  edtPrivateKeyRing.Text := PrivateKeyRingFile;
  edtMyCerts.Text := MyCertsFile;
  edtCollectedCerts.Text := CollectedCertsFile;

  UpdateServerLabel;
end;

procedure TfmSetup.FormHide(Sender: TObject);
begin
   UpdateServerLabel;
end;

procedure TfmSetup.BitBtn1Click(Sender: TObject);
var
  MailIni: TIniFile;
begin
  MailIni := TIniFile.Create(ExtractFilePath(ParamStr(0)) + 'Mail.ini');
  with MailIni do begin
    WriteString('Pop3', 'ServerName', POPServer.Text);
    Pop3ServerName := POPServer.Text;

    WriteString('Pop3', 'ServerPort', POPPort.Text);
    Pop3ServerPort := StrToIntDef(POPPort.Text, 110);

    WriteString('Pop3', 'ServerUser', Account.Text);
    Pop3ServerUser := Account.Text;

    WriteString('Pop3', 'ServerPassword', Password.Text);
    Pop3ServerPassword := Password.Text;

    WriteString('Smtp', 'ServerName', SMTPServer.Text);
    SmtpServerName := SMTPServer.Text;

    WriteString('Smtp', 'ServerPort', SMTPPort.Text);
    SmtpServerPort := StrToIntDef(SMTPPort.Text, 110);

    WriteString('Smtp', 'ServerUser', edtAccount.Text);
    SmtpServerUser := edtAccount.Text;

    WriteString('Smtp', 'ServerPassword', edtPassword.Text);
    SmtpServerPassword := edtPassword.Text;

    WriteString('Email', 'PersonalEmail', Email.Text);
    UserEmail := Email.Text;

    WriteInteger('Smtp', 'SMTPAuthenticationType', cboAuthType.ItemIndex);
    SmtpAuthType := cboAuthType.ItemIndex;

    WriteString('Smime', 'RootCerts', edtRootCerts.Text);
    RootCertsFile := edtRootCerts.Text;

    WriteString('Smime', 'PrivateKeyRing', edtPrivateKeyRing.Text);
    PrivateKeyRingFile := edtPrivateKeyRing.Text;
    
    WriteString('Smime', 'MyCerts', edtMyCerts.Text);
    MyCertsFile := edtMyCerts.Text;
    
    WriteString('Smime', 'CollectedCerts', edtCollectedCerts.Text);
    CollectedCertsFile := edtCollectedCerts.Text;
  end;
  MailIni.Free;
end;

procedure TfmSetup.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfmSetup.btnEditRootCertsClick(Sender: TObject);
begin
  frmMain.RootCertsSource.SCLFileName := edtRootCerts.Text;
  frmCertEdit.Caption := 'Select Certificates - Root Certificates';
  frmCertEdit.CertificateSelection1.CertSource := frmMain.RootCertsSource;
  frmCertEdit.CertificateSelection1.GroupIndex := 1;
  frmCertEdit.CertificateSelection1.DisplayAll;
  frmCertEdit.ShowModal;
  frmCertEdit.CertificateSelection1.CertSource := nil;
end;

procedure TfmSetup.btnEditMyCertsClick(Sender: TObject);
begin
  frmMain.RootCertsSource.SCLFileName := edtRootCerts.Text;
  frmMain.PrivateKeyRingSource.PrivateKeyRingFileName := edtPrivateKeyRing.Text;
  frmMain.MyCertsSource.SCLFileName := edtMyCerts.Text;
  frmCertEdit.Caption := 'Select Certificates - Personal Certificates';
  frmCertEdit.CertificateSelection1.CertSource := frmMain.MyCertsSource;
  frmCertEdit.CertificateSelection1.GroupIndex := 2;
  frmCertEdit.CertificateSelection1.DisplayAll;
  frmCertEdit.ShowModal;
  frmCertEdit.CertificateSelection1.PostGroupIndex;
  frmCertEdit.CertificateSelection1.CertSource := nil;
end;

procedure TfmSetup.btnEditCollectedCertsClick(Sender: TObject);
begin
  frmMain.RootCertsSource.SCLFileName := edtRootCerts.Text;
  frmMain.PrivateKeyRingSource.PrivateKeyRingFileName := edtPrivateKeyRing.Text;
  frmMain.MyCertsSource.SCLFileName := edtMyCerts.Text;
  frmMain.CollectedCertsSource.SCLFileName := edtCollectedCerts.Text;
  frmCertEdit.Caption := 'Select Certificates - Collected Certificates';
  frmCertEdit.CertificateSelection1.CertSource := frmMain.CollectedCertsSource;
  frmCertEdit.CertificateSelection1.GroupIndex := 3;
  frmCertEdit.CertificateSelection1.DisplayAll;
  frmCertEdit.ShowModal;
  frmCertEdit.CertificateSelection1.PostGroupIndex;
  frmCertEdit.CertificateSelection1.CertSource := nil;
end;

end.

