unit KDFDemoMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Mask;

type
  TfrmKDFDemoMain = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    memKeyResizing: TMemo;
    Label1: TLabel;
    MaskEdit1: TMaskEdit;
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Memo2: TMemo;
    Label2: TLabel;
    MaskEdit2: TMaskEdit;
    TabSheet2: TTabSheet;
    memKeySplitting: TMemo;
    Label3: TLabel;
    MaskEdit3: TMaskEdit;
    Button3: TButton;
    Memo3: TMemo;
    Label4: TLabel;
    MaskEdit4: TMaskEdit;
    Memo4: TMemo;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmKDFDemoMain: TfrmKDFDemoMain;

implementation

uses
  SecUtils, MpYarrow;

{$R *.dfm}

procedure TfrmKDFDemoMain.Button1Click(Sender: TObject);
var
  BitSize: Integer;
  PMS: array [0..2047] of Byte;
  PMSLen: Integer;
begin
  BitSize := StrToInt(Trim(MaskEdit1.Text));
  RawRandom(PMS,BitSize);
  PMSLen := (BitSize + 7) shr 3;
  Memo1.Text := BinToHex(PMS,PMSLen);
  ProtectClear(PMS,SizeOf(PMS));
end;

procedure TfrmKDFDemoMain.Button2Click(Sender: TObject);
var
  PMS, MasterSecret: array [0..2047] of Byte;
  PMSLen, MSLen: Integer;
  BitSize: Integer;
  KDFLabel: string;
begin
  PMSLen := Length(Memo1.Text) shr 1;
  HexToBin(Memo1.Text,PMS,PMSLen);
  BitSize := StrToInt(Trim(MaskEdit2.Text));
  MSLen := (BitSize + 7) shr 3;
  // Using a label is important, in particular if the same key material may
  // be used for more than one purpose or to generate keys of different lengths.
  // Always use a label which as specifically as possible describes the purpose
  // of the final key.
  KDFLabel := Format('Master Secret %d octets',[MSLen]);
  WeakPasswordToPrivKey(PMS,PMSLen,KDFLabel[1],Length(KDFLabel),1,MasterSecret,MSLen);
  Memo2.Text := BinToHex(MasterSecret,MSLen);
  ProtectClear(MasterSecret,SizeOf(MasterSecret));
  ProtectClear(PMS,SizeOf(PMS));
end;

procedure TfrmKDFDemoMain.Button3Click(Sender: TObject);
var
  BitSize: Integer;
  MS: array [0..2047] of Byte;
  MSLen: Integer;
begin
  BitSize := StrToInt(Trim(MaskEdit3.Text));
  RawRandom(MS,BitSize);
  MSLen := (BitSize + 7) shr 3;
  Memo3.Text := BinToHex(MS,MSLen);
  ProtectClear(MS,SizeOf(MS));
end;

procedure TfrmKDFDemoMain.Button4Click(Sender: TObject);
var
  MS, Key1, Key2: array [0..2047] of Byte;
  MSLen, KeyLen: Integer;
  BitSize: Integer;
  KDFLabel: string;
begin
  MSLen := Length(Memo3.Text) shr 1;
  HexToBin(Memo3.Text,MS,MSLen);
  BitSize := StrToInt(Trim(MaskEdit4.Text));
  KeyLen := (BitSize + 7) shr 3;
  // Using a label is important, in particular if the same key material may
  // be used for more than one purpose or to generate keys of different lengths.
  // Always use a label which as specifically as possible describes the purpose
  // of the final key.
  KDFLabel := Format('Key 1 %d octets',[KeyLen]);
  WeakPasswordToPrivKey(MS,MSLen,KDFLabel[1],Length(KDFLabel),1,Key1,KeyLen);
  KDFLabel := Format('Key 2 %d octets',[KeyLen]);
  WeakPasswordToPrivKey(MS,MSLen,KDFLabel[1],Length(KDFLabel),1,Key2,KeyLen);
  Memo4.Text := 'Key1:'#13#10 +
                BinToHex(Key1,KeyLen) + #13#10 +
                'Key2:'#13#10 +
                BinToHex(Key2,KeyLen);
  ProtectClear(Key2,SizeOf(Key2));
  ProtectClear(Key1,SizeOf(Key1));
  ProtectClear(MS,SizeOf(MS));
end;

end.
