unit QSignCodeMain;

interface

uses
  Classes,
{$IFDEF WIN32}
  Windows, Messages, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ActnList,
{$ENDIF}
{$IFDEF LINUX}
  Types, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QComCtrls, QActnList,
{$ENDIF}
  SysUtils, QExtCtrls, ExtCtrls;

type
  TfrmSignCodeMain = class(TForm)
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    edtExeFileName: TEdit;
    Label1: TLabel;
    btnBrowseExe: TButton;
    ActionList1: TActionList;
    actNext: TAction;
    actBack: TAction;
    Label2: TLabel;
    edtDescription: TEdit;
    Label3: TLabel;
    edtURL: TEdit;
    Label5: TLabel;
    edtPrivateKeyRing: TEdit;
    btnBrowsePKR: TButton;
    OpenDialog2: TOpenDialog;
    Label4: TLabel;
    edtMyCertificates: TEdit;
    btnBrowseUser: TButton;
    Label6: TLabel;
    edtRootCertificates: TEdit;
    btnBrowseRoot: TButton;
    OpenDialog3: TOpenDialog;
    btnCancel: TButton;
    Button1: TButton;
    actOK: TAction;
    Button2: TButton;
    Button3: TButton;
    chbCounterSign: TCheckBox;
    chbIncludeSigningTime: TCheckBox;
    rgStatementType: TRadioGroup;
    procedure btnBrowseExeClick(Sender: TObject);
    procedure actBackUpdate(Sender: TObject);
    procedure actNextUpdate(Sender: TObject);
    procedure actBackExecute(Sender: TObject);
    procedure actNextExecute(Sender: TObject);
    procedure btnBrowsePKRClick(Sender: TObject);
    procedure btnBrowseUserClick(Sender: TObject);
    procedure btnBrowseRootClick(Sender: TObject);
    procedure actOKUpdate(Sender: TObject);
    procedure actOKExecute(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure chbCounterSignClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSignCodeMain: TfrmSignCodeMain;

implementation

uses
  QSignCodeDM;

{$IFDEF LINUX}
{$R *.xfm}
{$ENDIF}
{$IFDEF WIN32}
{$R *.dfm}
{$ENDIF}

procedure TfrmSignCodeMain.btnBrowseExeClick(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    edtExeFileName.Text := OpenDialog1.FileName;
    chbCounterSign.Enabled := dmQSignCode.SignCode.CheckTrust(OpenDialog1.FileName);
  end;
end;

procedure TfrmSignCodeMain.actBackUpdate(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = 0 then
    actBack.Enabled := False
  else
    actBack.Enabled := True;
end;

procedure TfrmSignCodeMain.actNextUpdate(Sender: TObject);
begin
  case PageControl1.ActivePageIndex of
    0: actNext.Enabled := FileExists(edtExeFileName.Text);
    1: actNext.Enabled := True;
    2: actNext.Enabled := FileExists(edtPrivateKeyRing.Text) and
                          FileExists(edtMyCertificates.Text);
    3: actNext.Enabled := False;
  end;
end;

procedure TfrmSignCodeMain.actBackExecute(Sender: TObject);
begin
  PageControl1.ActivePageIndex := PageControl1.ActivePageIndex - 1;
end;

procedure TfrmSignCodeMain.actNextExecute(Sender: TObject);
begin
  PageControl1.ActivePageIndex := PageControl1.ActivePageIndex + 1;
end;

procedure TfrmSignCodeMain.btnBrowsePKRClick(Sender: TObject);
begin
  if OpenDialog2.Execute then
    edtPrivateKeyRing.Text := OpenDialog2.FileName;
end;

procedure TfrmSignCodeMain.btnBrowseUserClick(Sender: TObject);
begin
  if OpenDialog3.Execute then
    edtMyCertificates.Text := OpenDialog3.FileName;
end;

procedure TfrmSignCodeMain.btnBrowseRootClick(Sender: TObject);
begin
  if OpenDialog3.Execute then
    edtRootCertificates.Text := OpenDialog3.FileName;
end;

procedure TfrmSignCodeMain.actOKUpdate(Sender: TObject);
begin
  if PageControl1.ActivePageIndex = 3 then
    actOK.Enabled := True
  else
    actOK.Enabled := False;
end;

procedure TfrmSignCodeMain.actOKExecute(Sender: TObject);
begin
  dmQSignCode.ExeFileName := edtExeFileName.Text;
  dmQSignCode.CounterSign := chbCounterSign.Checked;
  dmQSignCode.IncludeSigningTime := chbIncludeSigningTime.Checked;
  dmQSignCode.StatementType := rgStatementType.ItemIndex;
  
  dmQSignCode.Description := edtDescription.Text;
  dmQSignCode.URL         := edtURL.Text;
                                                               
  dmQSignCode.RootCertificatesFileName := edtRootCertificates.Text;    
  dmQSignCode.PrivateKeyRingFileName := edtPrivateKeyRing.Text;
  dmQSignCode.MyCertificatesFileName := edtMyCertificates.Text;

  if dmQSignCode.PerformSignCode then
    Close;
end;

procedure TfrmSignCodeMain.btnCancelClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmSignCodeMain.FormShow(Sender: TObject);
begin
  edtURL.Text := dmQSignCode.URL;
  edtPrivateKeyRing.Text := dmQSignCode.PrivateKeyRingFileName;
  edtMyCertificates.Text := dmQSignCode.MyCertificatesFileName;
  edtRootCertificates.Text := dmQSignCode.RootCertificatesFileName;
end;

procedure TfrmSignCodeMain.chbCounterSignClick(Sender: TObject);
begin
  if chbCounterSign.Checked then begin    
    chbIncludeSigningTime.Enabled := False;
    chbIncludeSigningTime.Checked := True;
    rgStatementType.ItemIndex := 0;
    rgStatementType.Enabled := False;
  end else begin
    chbIncludeSigningTime.Enabled := True;
    chbIncludeSigningTime.Checked := False;
    rgStatementType.Enabled := True;
  end;
end;

end.
