unit ARC2TestMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    btnTest: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure btnTestClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  MPArith, ARC2, ASN1;

{$R *.DFM}

procedure TForm1.btnTestClick(Sender: TObject);
var
  C: TARC2_ECB;
  Key, PT, CT: string;
begin
  Memo1.Clear;
  C := TARC2_ECB.Create(nil^,0,0);
  try
    Key := HexToOS('00000000 00000000');
    C.EffectiveKeySize := 63;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('ebb773f9 93278eff')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 1')
    else
      Memo1.Lines.Add('Fail ecb test data: 1');

    Key := HexToOS('ffffffff ffffffff');
    C.EffectiveKeySize := 64;
    PT := HexToOS('ffffffff ffffffff');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);                  
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('278b27e4 2e2f0d49')) and
       (CT = HexToOS('ffffffff ffffffff')) then
      Memo1.Lines.Add('Good ecb test data: 2')
    else
      Memo1.Lines.Add('Fail ecb test data: 2');

    Key := HexToOS('30000000 00000000');
    C.EffectiveKeySize := 64;
    PT := HexToOS('10000000 00000001');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('30649edf 9be7d2c2')) and
       (CT = HexToOS('10000000 00000001')) then
      Memo1.Lines.Add('Good ecb test data: 3')
    else
      Memo1.Lines.Add('Fail ecb test data: 3');

    Key := HexToOS('88');
    C.EffectiveKeySize := 64;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('61a8a244 adacccf0')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 4')
    else
      Memo1.Lines.Add('Fail ecb test data: 4');

    Key := HexToOS('88bca90e 90875a');
    C.EffectiveKeySize := 64;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('6ccf4308 974c267f')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 5')
    else
      Memo1.Lines.Add('Fail ecb test data: 5');

    Key := HexToOS('88bca90e 90875a7f 0f79c384 627bafb2');
    C.EffectiveKeySize := 64;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('1a807d27 2bbe5db1')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 6')
    else
      Memo1.Lines.Add('Fail ecb test data: 6');

    Key := HexToOS('88bca90e 90875a7f 0f79c384 627bafb2');
    C.EffectiveKeySize := 128;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('2269552a b0f85ca6')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 7')
    else
      Memo1.Lines.Add('Fail ecb test data: 7');

    Key := HexToOS('88bca90e 90875a7f 0f79c384 627bafb2 16f80a6f 85920584' +
                   'c42fceb0 be255daf 1e');
    C.EffectiveKeySize := 129;
    PT := HexToOS('00000000 00000000');
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.Encrypt(Pointer(PT)^,Length(PT));
    CT := PT;
    UniqueString(CT);
    C.Decrypt(Pointer(CT)^,Length(CT));
    if (PT = HexToOS('5b78d3a4 3dfff1f1')) and
       (CT = HexToOS('00000000 00000000')) then
      Memo1.Lines.Add('Good ecb test data: 8')
    else
      Memo1.Lines.Add('Fail ecb test data: 8');

  finally
    C.Free;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  CEK, KEK, CT: string;
begin
  // IMPORTANT: Define KEYWRAPTEST in unit ARC2 before running this test.
  CEK := HexToOS('b70a 25fb c9d8 6a86 050c e0d7 11ea d4d9');
  KEK := HexToOS('fd04 fd08 0607 07fb 0003 feff fd02 fe05');
  SetLength(CT,40);
  ARC2KeyWrapEncrypt(Pointer(CEK)^,16,
                     Pointer(KEK)^,16,
                     Pointer(CT)^,40);
  if CT = HexToOS('70e6 99fb 5701 f783 3330 fb71 e87c 85a4' +
                  '20bd c99a f05d 22af 5a0e 48d3 5f31 3898' +
                  '6cba afb4 b28d 4f35') then
    Memo1.Lines.Add('OK')
  else
    Memo1.Lines.Add('Failure');
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  C: TARC2_ECB;
  Key, IV, PT, CT: string;
begin           
  Key := HexToOS('fd04 fd08 0607 07fb 0003 feff fd02 fe05');
  IV := HexToOS('c7d9 0059 b29e 97f7');
  CT := HexToOS('a01d a259 3793 1260 e48c 55f5 04ce 70b8' +
                'ac8c d79e ffe8 9932 9fa9 8a07 a31f f7a7');

  PT := HexToOS('10b7 0a25 fbc9 d86a 8605 0ce0 d711 ead4' +
                'd948 45cc e7fd 1250 0a6f f19f db40 4988');
  C := TARC2_CBC.Create(Pointer(Key)^,Length(Key),0);
  try
    C.EffectiveKeySize := 128;
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.IVector := IV;
    C.Encrypt(Pointer(PT)^,Length(PT));
  finally
    C.Free;
  end;                                      
  if PT = CT then
    Memo1.Lines.Add('Same')
  else
    Memo1.Lines.Add('Diff: ' + OSToHex(PT));

  PT := CT;
  UniqueString(PT);
  C := TARC2_CBC.Create(Pointer(Key)^,Length(Key),0);
  try
    C.EffectiveKeySize := 128;
    C.SetUp(Pointer(Key)^,Length(Key),0);
    C.IVector := IV;
    C.Decrypt(Pointer(PT)^,Length(PT));
  finally
    C.Free;
  end;
  if PT = HexToOS('10b7 0a25 fbc9 d86a 8605 0ce0 d711 ead4' +
                  'd948 45cc e7fd 1250 0a6f f19f db40 4988') then
    Memo1.Lines.Add('Same')
  else
    Memo1.Lines.Add('Diff: ' + OSToHex(PT));
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  CEK, KEK, CT: string;
begin
  // IMPORTANT: Define KEYWRAPTEST in unit ARC2 before running this test.
  KEK := HexToOS('fd04 fd08 0607 07fb 0003 feff fd02 fe05');
  CT := HexToOS('70e6 99fb 5701 f783 3330 fb71 e87c 85a4' +
                '20bd c99a f05d 22af 5a0e 48d3 5f31 3898' +
                '6cba afb4 b28d 4f35');
  SetLength(CEK,16);
  ARC2KeyWrapDecrypt(Pointer(CT)^,40,
                     Pointer(KEK)^,16,
                     Pointer(CEK)^,16);
  if CEK = HexToOS('b70a 25fb c9d8 6a86 050c e0d7 11ea d4d9') then
    Memo1.Lines.Add('OK')
  else
    Memo1.Lines.Add('Failure');
end;

end.
