unit RijndaelTestMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    btnECBEncr: TButton;
    btnECBDecr: TButton;
    btnCBCEncr: TButton;
    btnCBCDecr: TButton;
    procedure btnECBEncrClick(Sender: TObject);
    procedure btnECBDecrClick(Sender: TObject);
    procedure btnCBCEncrClick(Sender: TObject);
    procedure btnCBCDecrClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  IniFiles, SsRijndael, SsTwoFish, Asn1;

{$R *.DFM}

procedure TForm1.btnECBEncrClick(Sender: TObject);
var
  I, J, K: Integer;
  PT, CT: ShortString;
  Key, D, Msg: string;
  C: TRijndael_ECB;
  SL: TStringList;
begin
  btnECBEncr.Enabled := False;
  try
    Memo1.Clear;
    Memo1.Lines.Add('');
    Memo1.Lines.Add('=========================');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('FILENAME:  "ecb_e_m.txt"');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Electronic Codebook (ECB) Mode - ENCRYPTION');
    Memo1.Lines.Add('Monte Carlo Test');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Algorithm Name: Rijndael');
    Memo1.Lines.Add('Principal Submitter: Joan Daemen');
    Memo1.Lines.Add('');

    Memo1.Lines.BeginUpdate;
    try
      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=128');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,16);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Encrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(CT[K]));
      end;

      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=192');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,24);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Encrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := Copy(PT,9,8) + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=256');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,32);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Encrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := PT + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('===========');

    finally
      Memo1.Lines.EndUpdate;
    end;
    SL := TStringList.Create;
    try
      SL.LoadFromFile('Rijndael\ecb_e_m.txt');
      Msg := 'Good';
      for I := 0 to SL.Count - 1 do
        if Memo1.Lines[I] <> SL[I] then begin
          Msg := 'Fail: '#13#10 + SL[I] + #13#10 + Memo1.Lines[I];
          Break;
        end;
      ShowMessage(Msg);
    finally
      SL.Free;
    end;
  finally
    btnECBEncr.Enabled := True;
  end;
end;

procedure TForm1.btnECBDecrClick(Sender: TObject);
var
  I, J, K: Integer;
  PT, CT: ShortString;
  Key, D, Msg: string;
  C: TRijndael_ECB;
  SL: TStringList;
begin
  btnECBDecr.Enabled := False;
  try
    Memo1.Clear;
    Memo1.Lines.Add('');
    Memo1.Lines.Add('=========================');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('FILENAME:  "ecb_d_m.txt"');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Electronic Codebook (ECB) Mode - DECRYPTION');
    Memo1.Lines.Add('Monte Carlo Test');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Algorithm Name: Rijndael');
    Memo1.Lines.Add('Principal Submitter: Joan Daemen');
    Memo1.Lines.Add('');

    Memo1.Lines.BeginUpdate;
    try
      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=128');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,16);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Decrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(CT[K]));
      end;

      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=192');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,24);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Decrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := Copy(PT,9,8) + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('=========================');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=256');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,32);
      PT := StringOfChar(#0,16);
      CT := PT;
      for I := 0 to 399 do begin
        C := TRijndael_ECB.Create(Pointer(Key)^,Length(Key),0);
        try
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          for J := 0 to 9999 do begin
            PT := CT;
            C.Decrypt(CT[1],Length(CT));
          end;
          Memo1.Lines.Add('PT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := PT + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('===========');

    finally
      Memo1.Lines.EndUpdate;
    end;
    SL := TStringList.Create;
    try
      SL.LoadFromFile('Rijndael\ecb_d_m.txt');
      Msg := 'Good';
      for I := 0 to SL.Count - 1 do
        if Memo1.Lines[I] <> SL[I] then begin
          Msg := 'Fail: '#13#10 + SL[I] + #13#10 + Memo1.Lines[I];
          Break;
        end;
      ShowMessage(Msg);
    finally
      SL.Free;
    end;
  finally
    btnECBDecr.Enabled := True;
  end;
end;

procedure TForm1.btnCBCEncrClick(Sender: TObject);
var
  I, J, K: Integer;
  PT, CT, IV: string[16];
  Key, D, S, Msg: string;
  C: TRijndael_ECB;
  SL: TStringList;
begin
  btnCBCEncr.Enabled := False;
  try
    Memo1.Clear;
    Memo1.Lines.Add('');
    Memo1.Lines.Add('=========================');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('FILENAME:  "cbc_e_m.txt"');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Cipher Block Chaining (CBC) Mode - ENCRYPTION');
    Memo1.Lines.Add('Monte Carlo Test');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Algorithm Name: Rijndael');
    Memo1.Lines.Add('Principal Submitter: Joan Daemen');
    Memo1.Lines.Add('');

    Memo1.Lines.BeginUpdate;
    try
      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=128');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,16);
      PT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          for J := 0 to 9999 do begin
            CT := PT;
            PT := C.IVector;
            C.Encrypt(CT[1],Length(CT));
          end;
          IV := CT;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(CT[K]));
      end;

      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=192');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,24);
      PT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          for J := 0 to 9999 do begin
            CT := PT;
            PT := C.IVector;
            C.Encrypt(CT[1],Length(CT));
          end;
          IV := CT;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := Copy(PT,9,8) + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=256');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,32);
      PT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          for J := 0 to 9999 do begin
            CT := PT;
            PT := C.IVector;
            C.Encrypt(CT[1],Length(CT));
          end;
          IV := CT;
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := PT + CT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('==========');

    finally
      Memo1.Lines.EndUpdate;
    end;
    SL := TStringList.Create;
    try
      SL.LoadFromFile('Rijndael\cbc_e_m.txt');
      Msg := 'Good';
      for I := 0 to SL.Count - 1 do
        if Memo1.Lines[I] <> SL[I] then begin
          S := Memo1.Lines[I];
          if (S = StringOfChar('=',Length(S))) and
             (SL[I] = StringOfChar('=',Length(SL[I]))) then
            Continue;
          Msg := 'Fail: '#13#10 + SL[I] + #13#10 + Memo1.Lines[I];
          Break;
        end;
      ShowMessage(Msg);
    finally
      SL.Free;
    end;
  finally
    btnCBCEncr.Enabled := True;
  end;
end;

procedure TForm1.btnCBCDecrClick(Sender: TObject);
var
  I, J, K: Integer;
  PT, CT, IV: string[16];
  Key, D, S, Msg: string;
  C: TRijndael_ECB;
  SL: TStringList;
begin
  btnCBCDecr.Enabled := False;
  try
    Memo1.Clear;
    Memo1.Lines.Add('');
    Memo1.Lines.Add('=========================');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('FILENAME:  "cbc_d_m.txt"');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Cipher Block Chaining (CBC) Mode - DECRYPTION');
    Memo1.Lines.Add('Monte Carlo Test');
    Memo1.Lines.Add('');
    Memo1.Lines.Add('Algorithm Name: Rijndael');
    Memo1.Lines.Add('Principal Submitter: Joan Daemen');
    Memo1.Lines.Add('');

    Memo1.Lines.BeginUpdate;
    try
      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=128');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,16);
      CT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          PT := CT;
          for J := 0 to 9999 do
            C.Decrypt(PT[1],Length(PT));
          IV := C.IVector;
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          CT := PT;
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(PT[K]));
      end;

      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=192');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,24);
      PT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        CT := PT;
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          PT := CT;
          for J := 0 to 9999 do begin
            CT := PT;
            C.Decrypt(PT[1],Length(PT));
          end;
          IV := C.IVector;
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := Copy(CT,9,8) + PT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('==========');
      Memo1.Lines.Add('');
      Memo1.Lines.Add('KEYSIZE=256');
      Memo1.Lines.Add('');

      Key := StringOfChar(#0,32);
      PT := StringOfChar(#0,16);
      IV := StringOfChar(#0,16);
      for I := 0 to 399 do begin
        CT := PT;
        C := TRijndael_CBC.Create(Pointer(Key)^,Length(Key),0);
        try
          C.IVector := IV;
          Memo1.Lines.Add('I=' + IntToStr(I));
          Memo1.Lines.Add('KEY='+ OSToHex(Key,True));
          Memo1.Lines.Add('IV=' + OSToHex(IV,True));
          Memo1.Lines.Add('CT=' + OSToHex(CT,True));
          PT := CT;
          for J := 0 to 9999 do begin
            CT := PT;
            C.Decrypt(PT[1],Length(PT));
          end;
          IV := C.IVector;
          Memo1.Lines.Add('PT=' + OSToHex(PT,True));
          Memo1.Lines.Add('');
        finally
          C.Free;
        end;
        D := CT + PT;
        for K := 1 to Length(Key) do
          Key[K] := Char(Byte(Key[K]) xor Byte(D[K]));
      end;

      Memo1.Lines.Add('==========');

    finally
      Memo1.Lines.EndUpdate;
    end;
    SL := TStringList.Create;
    try
      SL.LoadFromFile('Rijndael\cbc_d_m.txt');
      Msg := 'Good';
      for I := 0 to SL.Count - 1 do
        if Memo1.Lines[I] <> SL[I] then begin
          S := Memo1.Lines[I];
          if (S = StringOfChar('=',Length(S))) and
             (SL[I] = StringOfChar('=',Length(SL[I]))) then
            Continue;
          Msg := 'Fail: '#13#10 + SL[I] + #13#10 + Memo1.Lines[I];
          Break;
        end;
      ShowMessage(Msg);
    finally
      SL.Free;
    end;
  finally
    btnCBCDecr.Enabled := True;
  end;
end;

end.
