unit TwoFishTestMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    btnTest: TButton;
    procedure btnTestClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  IniFiles, TwoFish, ASN1;

{$R *.DFM}

procedure TForm1.btnTestClick(Sender: TObject);
var
  Ini: TMemIniFile;
  Sects: TStringList;
  C: TTwoFish_ECB;
  I: Integer;
  Key, Data, S: string;
begin
  Memo1.Clear;
  Ini := TMemIniFile.Create('ecb_tbl.txt');
  try
    Sects := TStringList.Create;
    try
      Ini.ReadSections(Sects);
      C := TTwofish_ECB.Create(nil^,0,0);
      try
        for I := 0 to Sects.Count - 1 do begin
          Key := HexToOS(Ini.ReadString(Sects[I],'KEY',''));
          C.SetUp(Pointer(Key)^,Length(Key),0);
          Data := HexToOS(Ini.ReadString(Sects[I],'PT',''));
          S := Data;
          UniqueString(S);
          C.Encrypt(Pointer(S)^,Length(S));
          if CompareText(OSToHex(S,True),Ini.ReadString(Sects[I],'CT','')) = 0 then begin
            Memo1.Lines.Add(Format('Encrypt OK %s',[Sects[I]]));
            C.Decrypt(Pointer(S)^,Length(S));
            if S = Data then
              Memo1.Lines.Add(Format('Decrypt OK %s',[Sects[I]]))
            else
              Memo1.Lines.Add(Format('Decrypt FAILED %s',[Sects[I]]));
          end else
            Memo1.Lines.Add(Format('Encrypt FAILED %s',[Sects[I]]));
        end;
      finally
        C.Free;
      end;
    finally
      Sects.Free;
    end;
  finally
    Ini.Free;
  end;
end;

end.
